// .... .... .....!
// ...... ......!
// .... ....... ..... ..!

#include <bits/stdc++.h>
using namespace std;

#define rep(i, n) for (int i = 0, _n = (int)(n); i < _n; i++)
#define fer(i, x, n) for (int i = (int)(x), _n = (int)(n); i < _n; i++)
#define rof(i, n, x) for (int i = (int)(n), _x = (int)(x); i-- > _x; )
#define sz(x) (int((x).size()))
#define pb push_back
#define all(X) (X).begin(),(X).end()
#define X first
#define Y second

template<class P, class Q> inline void smin(P &a, Q b) { if (b < a) a = b; }
template<class P, class Q> inline void smax(P &a, Q b) { if (a < b) a = b; }

typedef long long ll;
typedef pair<int, int> pii;

////////////////////////////////////////////////////////////////////////////////

const int maxn = 5000 + 10;

int w, h, n;
pii p[maxn];
ll dis[maxn][maxn];
ll sp[maxn];
bool mark[maxn];

int main() {
	ios_base::sync_with_stdio(false); cin.tie(0);

	int ttt; cin >> ttt;
	while(ttt--) {
		cin >> w >> h >> n;
		cerr << " ~~ " << n << endl;
		rep(i, n) cin >> p[i].X >> p[i].Y;

		rep(i, n) rep(j, i) dis[i][j] = dis[j][i] = (p[i].X-p[j].X)*(ll)(p[i].X-p[j].X) + (p[i].Y-p[j].Y)*(ll)(p[i].Y-p[j].Y);
		rep(i, n) dis[i][n] = dis[n][i] = p[i].X * (ll)p[i].X;
		n++;
		rep(i, n-1) dis[i][n] = dis[n][i] = (w - p[i].X) * (ll)(w - p[i].X);
		n++;
		dis[n-2][n-1] = dis[n-1][n-2] = w*(ll)w;

		fill(sp, sp+n, 1LL<<61);
		fill(mark, mark+n, false);
		sp[n-2] = 0;

		rep(z, n) {
			int u = -1;
			rep(i, n) if(!mark[i] && (u == -1 || sp[i] < sp[u])) u = i;
			mark[u] = true;
			rep(i, n) smin(sp[i], max(sp[u], dis[u][i]));
		}

		cout.setf(ios::fixed);
		cout.precision(2);
		cout << sqrt(sp[n-1]) / 2 << endl;
	}

	return 0;
}

